'callerODBC.bas - Based on an example in the LB tutorial
'This example requires the existence of an ODBC data source named CALLERLOG

  global #db
  call createTable

[menu]  'display menu options
  cls
  print "**Caller Log Program**"
  print
  print " 1) Enter a phone call"
  print " 2) Search by caller's name"
  print " 3) Search by person called"
  print " 4) Quit"
  print
  print "Choose an option from 1 to 4."
  input ">"; option
  if option < 1 or option > 4 then gosub [badOption]
  if option = 1 then gosub [enterAPhoneCall]
  if option = 2 then gosub [searchByCallersName]
  if option = 3 then gosub [searchByPersonCalled]
  if option = 4 then [quit]
  goto [menu]

[badOption]  'display a notice that a bad selection was made
  print
  print "Option "; option; " is unsupported."
  input "Press Enter."; a$
  return

[enterAPhoneCall]  'accept a phone log entry from the user
  cls
  print "**Enter a Phone Call**"
  print
  input "Caller's name ?"; callersName$
  input "Name of person called ?"; personCalled$
  input "Date of call (press 'Enter' for "+date$()+") ?"; dateOfCall$
  if dateOfCall$ = "" then dateOfCall$ = date$()
  input "Time of call (press 'Enter' for "+time$()+") ?"; timeOfCall$
  if timeOfCall$ = "" then timeOfCall$ = time$()
  input "Purpose of call ?"; purposeOfCall$
  input "Phone # where the caller can be reached ?"; callersPhone$

[saveEditCancelLoop]  'give the user the option to save, edit or abort
  cls
  gosub [displayEntryInfo]
  input "Save, Edit, Cancel Entry (S/E/C)?"; answer$
  if answer$ = "S" or answer$ = "s" then gosub [saveEntry] : goto [menu]
  if answer$ = "E" or answer$ = "e" then gosub [editEntry]
  if answer$ = "C" or answer$ = "c" then [menu]
  goto [saveEditCancelLoop]

[displayEntryInfo]  'display call information
  print "       Caller's name : "; callersName$
  print "   Name of person called : "; personCalled$
  print "      Date of call : "; dateOfCall$
  print "      Time of call : "; timeOfCall$
  print "     Purpose of call : "; purposeOfCall$
  print "Caller can be reached at : "; callersPhone$
  return

[editEntry]  'edit call information
  cls
  print "**Edit Caller Entry**"
  print
  print "       Caller's name : "; callersName$
  input "  Press Enter, or retype > "; newEntry$
  if newEntry$ <> "" then callersName$ = newEntry$
  print "   Name of person called : "; personCalled$
  input "  Press Enter, or retype > "; newEntry$
  if newEntry$ <> "" then personCalled$ = newEntry$
  print "      Date of call : "; dateOfCall$
  input "  Press Enter, or retype > "; newEntry$
  if newEntry$ <> "" then dateOfCall$ = newEntry$
  print "      Time of call : "; timeOfCall$
  input "  Press Enter, or retype > "; newEntry$
  if newEntry$ <> "" then timeOfCall$ = newEntry$
  print "     Purpose of call : "; purposeOfCall$
  input "  Press Enter, or retype > "; newEntry$
  if newEntry$ <> "" then purposeOfCall$ = newEntry$
  print "Caller can be reached at : "; callersPhone$
  input "  Press Enter, or retype > "; newEntry$
  if newEntry$ <> "" then callersPhone$ = newEntry$
  return

[saveEntry]  'write the entry info to the database
  call connect
  #db execute("INSERT INTO CALLS 
		(CALLERSNAME, PERSONCALLED, DATEOFCALL, TIMEOFCALL, PURPOSEOFCALL, CALLERSPHONE) 
		VALUES('"+callersName$+"', '"+personCalled$+"', '"+dateOfCall$+"', '"+timeOfCall$+"', '"+purposeOfCall$+"', '"+callersPhone$+"')")
  call disconnect
  return

[searchByCallersName]  'look for a phone log entry by caller's name
  cls
  print "**Search by Caller's Name**"
  print
  print "Please enter a partial name to search by."
  input ">"; searchCaller$
  if searchCaller$ = "" then [menu]  'nothing entered, abort search
  call searchUsingQuery "SELECT * FROM CALLS WHERE CALLERSNAME LIKE '%"+searchCaller$+"%'"
  input "Press Enter."; a$
  goto [menu]

[searchByPersonCalled]  'look for a phone log entry by person called
  cls
  print "**Search by Person Called**"
  print
  print "Please enter a partial name to search by."
  input ">"; searchCalled$
  if searchCalled$ = "" then [menu]  'nothing entered, abort search
  call searchUsingQuery "SELECT * FROM CALLS WHERE PERSONCALLED LIKE '%"+searchCalled$+"%'"
  input "Press Enter."; a$
  goto [menu]

sub searchUsingQuery query$
  call connect
  #db execute(query$)
  if #db hasAnswer() then
    while #db hasAnswer()
      #row = #db #nextRow()
      print #row
      print #row callersname$();","; #row personcalled$();","; #row dateofcall$();","; #row timeofcall$();",";_
        #row purposeofcall$();","; #row callersphone$()
    wend
    call disconnect
  else
    call disconnect
    print "No matches."
  end if
end sub

[quit]  'end here
  print "Quitting."
  end

sub createTable
  call connect
  #db execute("select distinct name from sys.tables where name = 'CALLS'")
  if #db hasanswer() = 0 then
    #db execute("create table CALLS(CALLERSNAME varchar(255), PERSONCALLED varchar(255), DATEOFCALL varchar(255),"_
       + " TIMEOFCALL varchar(255), PURPOSEOFCALL varchar(255), CALLERSPHONE varchar(255));")
  end if
  call disconnect
end sub

sub connect
  sqlserverconnect #db, "CALLERLOG", "username", "password"
end sub

sub disconnect
  #db disconnect()
end sub

function doubleQuote$(string$)
  if instr(string$, chr$(34)) then
    for x = 1 to len(string$)
      if mid$(string$, x, 1) = chr$(34) then doubleQuote$ = doubleQuote$ + chr$(34)
      doubleQuote$ = doubleQuote$ + mid$(string$, x, 1)
    next x
  else
      doubleQuote$ = string$
  end if
end function
