'shortcut.dll is a small, free 32-bit only DLL that allows your program
'to create desktop and startmenu shortcuts. It is written by
'Alyce Watson, April 14, 2005.
'This DLL may be distributed freely, no credit necessary to author.
'You may not claim this DLL as your own work.
'Main code by Paul Turley, rendered as DLL by Alyce Watson.
'
'Syntax:
'DESKTOP SHORTCUT
'open "shorcut.dll" for dll as #d
'calldll #d, "CreateDesktopShortCut",_ 'function name
'   file$$ as ptr,_     'full path to executable program or file
'   lnk$ as ptr,_       'name of shorcut
'   desc$ as ptr,_      'description
'   result as long      'returns nonzero on success
'close #d
'
'STARTMENU SHORTCUT
'open "shorcut.dll" for dll as #d
'calldll #d, "CreateStartMenuShortCut",_ 'function name
'   file$$ as ptr,_     'full path to executable program or file
'   lnk$ as ptr,_       'name of shorcut
'   desc$ as ptr,_      'description
'   result as long      'returns nonzero on success
'close #d

'Instructions:
'The three strings for the arguments must each be no
'longer than 260 characters.
'
'The file$ should be the full path to the executable program or file.
'The lnk$ is the text that appears on the desktop - the shorcut name.
'The desc$ is the description that appears in the comment line in
'   the shorcut properites window.
'
'******************************************************************
'DEMO
'The filedialog is used for demonstration purposes.
'Instead of using a filedialog, you may
'hard-code a path to the executable program.

filedialog "Open", "*.exe;*.*", file$
if file$="" then end
'use short path version if the path is longer than 259
if len(file$)>259 then file$=GetShortPathName$(file$)

lnk$="Link Name"
prompt "Link Name?"; lnk$
if lnk$="" then lnk$="MyProgram"
if len(lnk$)>259 then lnk$=left$(lnk$,259)

desc$="Shorcut Description"
prompt "Description?"; desc$
if desc$="" then desc$="My Shortcut"
if len(desc$)>259 then desc$=left$(desc$,259)

'create shortcut on desktop
open "shortcut.dll" for dll as #d
calldll #d, "CreateDesktopShortCut",_
    file$ as ptr, lnk$ as ptr, desc$ as ptr,_
    result as long
close #d

'check to see if it worked
if result > 0 then
    print "Desktop Shortcut Created!"
else
    print "Oops. Unable to create desktop shortcut."
end if


'add to startmenu
open "shortcut.dll" for dll as #d
calldll #d, "CreateStartMenuShortCut",_
    file$ as ptr, lnk$ as ptr, desc$ as ptr,_
    result as long
close #d

'check to see if it worked
if result > 0 then
    print "StartMenu Shortcut Created!"
else
    print "Oops. Unable to create startmenu shortcut."
end if
end


'returns short path name for a disk file
Function GetShortPathName$(lPath$)
    lPath$=lPath$+Chr$(0)
    sPath$=Space$(256)
    lenPath=Len(sPath$)
    CallDLL #kernel32, "GetShortPathNameA",lPath$ As Ptr,_
    sPath$ As Ptr,lenPath As Long,r As Long
    GetShortPathName$=Left$(sPath$,r)
    End Function
