
'test_file_encoding.bas
'Supported encoders are:
'       iso8859_1 (the default)
'       ascii
'       utf_8
'       ms_cp_1252

'------------- test ISO8859-1

    print "Testing iso8859-1 encoding (the default)."
    open "encoding-test.dat" for output as #fileHandle ' encoder = iso8859_1
    for x = 0 to 255
        print #fileHandle, chr$(x);
    next x
    close #fileHandle

    open "encoding-test.dat" for input as #fileHandle ' encoder = iso8859_1
    size = lof(#fileHandle)
    print "reading "; size; " bytes."
    code$ = input$(#fileHandle, size)
    print "Read "; len(code$); " bytes."
    print code$
    close #fileHandle
    print

'------------- test MSCP-1252
    print "-----------------------------------------"
    print "Testing mscp-1252 encoding."
    open "encoding-test.dat" for output as #fileHandle encoder = ms_cp_1252
    for x = 0 to 255
        print #fileHandle, chr$(x);
    next x
    close #fileHandle

    open "encoding-test.dat" for input as #fileHandle encoder = ms_cp_1252
    size = lof(#fileHandle)
    print "reading "; size; " bytes."
    code$ = input$(#fileHandle, size)
    print "Read "; len(code$); " bytes."
    print code$
    close #fileHandle
    print

'------------- test ASCII
    print "-----------------------------------------"
    print "Testing ASCII encoding."
    open "encoding-test.dat" for output as #fileHandle encoder = ascii
    for x = 0 to 127
        print #fileHandle, chr$(x);
    next x
    close #fileHandle

    open "encoding-test.dat" for input as #fileHandle encoder = ascii
    size = lof(#fileHandle)
    print "reading "; size; " bytes."
    code$ = input$(#fileHandle, size)
    print "Read "; len(code$); " bytes."
    print code$
    close #fileHandle
    print

'------------- test UTF-8
    print "-----------------------------------------"
    print "Testing UTF-8 encoding."
    print "In UTF-8 bytes and characters are not usually the same."
    print "ASCII from 0 to 127 does make number of chars = bytes for example:"
    open "encoding-test.dat" for output as #fileHandle encoder = utf_8
    for x = 0 to 127
        print #fileHandle, chr$(x);
    next x
    close #fileHandle

    open "encoding-test.dat" for input as #fileHandle encoder = utf_8
    size = lof(#fileHandle)
    print "reading "; size; " bytes."
    code$ = input$(#fileHandle, size)
    print "Read "; len(code$); " bytes."
    print code$
    close #fileHandle
    print

    print "Now read a UTF-8 example file but we cannot use input$(lof())"
    print "because lof() returns bytes but input$() is expecting characters."
    print "So we will read and encode each character separately."

    open "utf-8-test.txt" for input as #fileHandle encoder = utf_8
    size = lof(#fileHandle)
    print "reading "; size; " bytes."

    while eof(#fileHandle) = 0
        utf8$ = utf8$ + input$(#fileHandle, 1)
    wend
    print "Read "; len(utf8$); " characters."
    print utf8$

    close #fileHandle
    end
